Index: issm/trunk/scripts/mail
===================================================================
--- issm/trunk/scripts/mail	(revision 12332)
+++ issm/trunk/scripts/mail	(revision 12332)
@@ -0,0 +1,158 @@
+#!/bin/sh
+
+# This is a shell script to emulate the standard mail(1) aka mailx(1)
+# aka Mail(1) tool usage for sending emails. This shell script is not
+# a client for checking or reading mail. Also, this version of mail
+# does not touch any mail boxes.
+
+# Copyright (c) 2003 by Jeremy C. Reed
+# This software is provided "as is" without any warranties. You may
+# redistribute and use this source, with or without modification,
+# as long as you include this copyright and disclaimer.
+
+# To do: some switches to consider:
+# -v  display details of delivery
+# -E  do not send empty messages
+# -c  send carbon copies to users
+# -b  send blind carbon copies
+
+# todo: test if read can read in long enough lines
+# some shells may have limit of 256 characters per read?
+ 
+SENDMAIL=sendmail  # set to path of your sendmail(8) command
+SENDMAIL_ARGS="-t -i" # -i is so dot doesn't terminate message
+                      # -t is to get recipients from headers
+
+unset subject
+unset to_addr
+dontsendempty=0
+
+about ()
+{
+  echo "This is mailx.sh version 0.03. This is simple, shell script"
+  echo "to implement mailx(1) functionality for sending mail. It does"
+  echo "not provide an interface for checking or reading email messages."
+  echo
+
+  # maybe do this without forking a command
+  mailname=$( basename $0 )
+
+  if [ -n "$1" ] ; then
+    echo "$mailname: $1" 1>&2
+  fi
+
+  echo "Usage: $mailname [-s subject] to-addr ..." 1>&2
+
+  if [ -n "$1" ] ; then
+    if [ -n "$2" ] ; then 
+      exit $2
+    fi
+    exit 100
+  fi
+
+  exit 0
+}
+
+if [ $# -eq 0 ] ; then
+  about "Sorry, this is not a mail reader." 1
+fi
+
+while [ -n "$1" ] ; do
+  case "$1" in
+  -*)
+      if [ "$1" = "-s" ] ; then
+        if [ -z "$2" ] ; then
+          about "The \"-s\" option requires an argument." 4
+        fi
+        subject="$2"
+        shift
+      elif [ "$1" = "-u" -o "$1" = "-f" ] ; then
+        about "Sorry, this is not a mail reader." 2
+#      elif [ "$1" = "-E" ] ; then
+# this probably needs to have entire message saved to temp file first
+#        dontsendempty=1
+      else
+#        about "unknown option -- $1" 3
+        about "Switch \"$1\" is not implemented." 3
+      fi
+      ;;
+  *)  if [ -n "$to_addr" ] ; then
+        to_addr="${to_addr}, $1"
+      else
+        to_addr="$1"
+      fi
+      ;;
+  esac
+  shift
+done
+
+
+if [ -t 0 ] ; then   # no piped in standard input
+  if [ -z "$subject" ] ; then
+    echo -n "Subject: "
+    OLD_IFS=$IFS
+    IFS=""
+    read -r subject
+    IFS=$OLD_IFS
+  fi
+fi
+
+if [ -z "$to_addr" ] ; then
+  about "No recipients specified." 6
+#  about "You must specify recipients." 6
+fi
+
+# generate SMTP headers
+
+# mail(1) doesn't seem to set date
+#date +"Date: %a, %e %b %G %T %z"
+## maybe pipe though sed to get rid of extra space
+## before single digit day of month?
+
+{
+# if [ -n "$to_addr" ] ; then
+echo "To: ${to_addr}"
+# fi
+
+if [ -n "$subject" ] ; then
+  echo "Subject: $subject"
+fi
+
+# end of headers
+echo ""
+
+# output
+line_count=0
+OLD_IFS=$IFS
+IFS=""
+while read -r line ; do
+  # finish if manual, non-piped input is a period on a line by itself
+  if [ "$line" = "." -a -t 0 ] ; then
+      break
+  fi
+  echo "$line"
+  line_count=$(( line_count + 1 ))
+done
+
+IFS=$OLD_IFS
+
+if [ -t 0 ] ; then   # no piped in standard input
+  echo "EOT" 1>&2
+fi
+
+# later add switch to not send mail by exiting
+if [ "$line_count" -eq 0 ] ; then
+#  if [ "$dontsendempty" -eq 1 ] ; then
+# todo this, have it save to temp file and then send to sendmail as needed
+#    # No message, so just exit cleanly
+#    exit 0
+#  fi
+  if [ -z "$subject" ] ; then
+    echo "No message, no subject; hope that's ok" 1>&2
+  else
+    echo "Null message body; hope that's ok" 1>&2
+  fi
+fi
+
+} | $SENDMAIL $SENDMAIL_ARGS
+
Index: issm/trunk/scripts/report.sh
===================================================================
--- issm/trunk/scripts/report.sh	(revision 12331)
+++ issm/trunk/scripts/report.sh	(revision 12332)
@@ -49,5 +49,5 @@
 
 #create some variables
-if [ $(ls -1 $ISSM_TIER/bin | wc -l) -le 20 ];
+if [ $(ls -1 $ISSM_DIR/bin | wc -l) -le 20 ];
 then
 	IS_INSTALL=0
Index: issm/trunk/scripts/run.sh
===================================================================
--- issm/trunk/scripts/run.sh	(revision 12331)
+++ issm/trunk/scripts/run.sh	(revision 12332)
@@ -6,6 +6,6 @@
 MATLAB_VERSION="7.6" #7.2,7.4,7.6 and 7.8
 #create softlink to startup {{{1
-cd $ISSM_TIER/test/NightlyRun/
-ln -s $ISSM_TIER/startup.m .
+cd $ISSM_DIR/test/NightlyRun/
+ln -s $ISSM_DIR/startup.m .
 #}}}
 
@@ -14,8 +14,8 @@
 do
 	#Launch matlab and the daily run script
-	cat > $ISSM_TIER/dailylog/matlab_run$i.m << EOF
+	cat > $ISSM_DIR/dailylog/matlab_run$i.m << EOF
 	warning off %necessary to avoid a daily.log of several Go for parallel runs
 	try,
-		cd $ISSM_TIER/test/NightlyRun
+		cd $ISSM_DIR/test/NightlyRun
 		startup;
 		$(if [ "$NROPTIONS" = ""  ]
@@ -30,5 +30,5 @@
 		directory=strsplit(pwd,'/');
 		message=getReport(me)
-		fid=fopen([ISSM_TIER '/dailylog/matlaberror.log'], 'at');
+		fid=fopen([ISSM_DIR '/dailylog/matlaberror.log'], 'at');
 		fprintf(fid,'\nMatlab error occured in: %s\n\n',directory{end});
 		fprintf(fid,'%s',message);
@@ -39,5 +39,5 @@
 
 	#Start run from dailylog directory
-	cd $ISSM_TIER/dailylog/
+	cd $ISSM_DIR/dailylog/
 
 	#Start test
Index: issm/trunk/scripts/windowsbuild.sh
===================================================================
--- issm/trunk/scripts/windowsbuild.sh	(revision 12331)
+++ issm/trunk/scripts/windowsbuild.sh	(revision 12332)
@@ -11,5 +11,5 @@
 today=`today_date`
 
-cd $ISSM_TIER/bin
+cd $ISSM_DIR/bin
 
 #Filter out .svn files
Index: issm/trunk/startup.m
===================================================================
--- issm/trunk/startup.m	(revision 12331)
+++ issm/trunk/startup.m	(revision 12332)
@@ -11,35 +11,35 @@
 lastwarn(''); 
 
-%Recover ISSM_TIER , or if on a Windows machine, ISSM_TIER_WIN
+%Recover ISSM_DIR , or if on a Windows machine, ISSM_DIR_WIN
 if ~ispc,
-	ISSM_TIER=getenv('ISSM_TIER');
+	ISSM_DIR=getenv('ISSM_DIR');
 else
-	ISSM_TIER=getenv('ISSM_TIER_WIN');
-	%ISSM_TIER='';
+	ISSM_DIR=getenv('ISSM_DIR_WIN');
+	%ISSM_DIR='';
 end
-if (isempty(ISSM_TIER)),
-	error('''ISSM_TIER'' environment variable is empty! You should define ISSM_TIER in your .cshrc or .bashrc!');
+if (isempty(ISSM_DIR)),
+	error('''ISSM_DIR'' environment variable is empty! You should define ISSM_DIR in your .cshrc or .bashrc!');
 end
 
 %Now add all issm code paths necessary to run issm smoothly. 
 %We capture the error output, so that we can warn the user to update 
-%the variable ISSM_TIER in this file, in case it is not correctly setup. 
+%the variable ISSM_DIR in this file, in case it is not correctly setup. 
 
 %ISSM path
-addpath([ISSM_TIER '/src/m/utils/']); %loads recursivepath
-addpath([ISSM_TIER '/bin']);
-addpath(recursivepath([ISSM_TIER '/src/m']));
-addpath(recursivepath([ISSM_TIER '/externalpackages/scotch']));
-addpath(recursivepath([ISSM_TIER '/externalpackages/canos']));
-addpath(recursivepath([ISSM_TIER '/externalpackages/kml']));
-addpath(recursivepath([ISSM_TIER '/externalpackages/export_fig']));
-addpath(recursivepath([ISSM_TIER '/externalpackages/googleearthtoolbox']));
-addpath(recursivepath([ISSM_TIER '/externalpackages/cm_and_cb_utilities']));
+addpath([ISSM_DIR '/src/m/utils/']); %loads recursivepath
+addpath([ISSM_DIR '/bin']);
+addpath(recursivepath([ISSM_DIR '/src/m']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/scotch']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/canos']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/kml']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/export_fig']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/googleearthtoolbox']));
+addpath(recursivepath([ISSM_DIR '/externalpackages/cm_and_cb_utilities']));
 
-clear ISSM_TIER;
+clear ISSM_DIR;
 
 %Check on any warning messages that might indicate that the paths were not correct. 
 if ~isempty(lastwarn),
-	fprintf('\n  Error trying to setup ''ISSM'' code paths. Try and update the ISSM_TIER variable in your .cshrc or .bashrc!\n');
+	fprintf('\n  Error trying to setup ''ISSM'' code paths. Try and update the ISSM_DIR variable in your .cshrc or .bashrc!\n');
 	fprintf('  ''ISSM'' will not  work at all until this is resolved\n\n');
 else
Index: issm/trunk/startup.py
===================================================================
--- issm/trunk/startup.py	(revision 12331)
+++ issm/trunk/startup.py	(revision 12332)
@@ -5,27 +5,30 @@
 #  before handing over the prompt to the user if the environment variable
 #  PYTHONSTARTUP is defined:
-#  export PYTHONSTARTUP=$ISSM_TIER/startup.py
+#  export PYTHONSTARTUP=$ISSM_DIR/startup.py
 #  This startup script should be run by users before trying to use ISSM.
 
 import os,sys
 
- 
-#First check we are running python 3 at least 
-if sys.version_info[0] < 3:
-	print("ISSM can only work in Python 3. Exiting python")
-	sys.exit(1)
-
-#Recover ISSM_TIER, ISSM_DIR  and USERNAME
-ISSM_TIER=os.getenv('ISSM_TIER')
+#Recover ISSM_DIR and USERNAME
+ISSM_DIR=os.getenv('ISSM_DIR')
 USERNAME =os.getenv('USER')
-if(ISSM_TIER==None):
-	raise NameError('"ISSM_TIER" environment variable is empty! You should define ISSM_TIER in your .cshrc or .bashrc!')
+if(ISSM_DIR==None):
+	raise NameError('"ISSM_DIR" environment variable is empty! You should define ISSM_DIR in your .cshrc or .bashrc!')
 
 #Now add all issm code paths necessary to run issm smoothly. 
 #We capture the error output, so that we can warn the user to update 
-#the variable ISSM_TIER in this file, in case it is not correctly setup. 
+#the variable ISSM_DIR in this file, in case it is not correctly setup. 
 
 #ISSM path. Go through src/py and load everything we find  that looks like a python file
-for root,dirs,files in os.walk(ISSM_TIER+ '/src/py'):
+for root,dirs,files in os.walk(ISSM_DIR+ '/src/py'):
+	for file in files:
+		if file.find(".py") != -1:
+			if file.find(".pyc") == -1:
+				#add to path 
+				sys.path.append(root)
+				file=os.path.splitext(file)[0]
+				#__import__(file)
+
+for root,dirs,files in os.walk(ISSM_DIR+ '/src/m'):
 	for file in files:
 		if file.find(".py") != -1:
@@ -36,5 +39,5 @@
 				#__import__(file)
 				
-sys.path.append(ISSM_TIER + '/src/mex')
+sys.path.append(ISSM_DIR + '/src/modules/python')
 
 #Deal with scipy import: 
@@ -79,5 +82,6 @@
 from miscellaneous import *
 from private import *
-from TriMesh import *
+from triangle import *
+from setmask import *
 
 #}}}
Index: issm/trunk/test/NightlyRun/runme.m
===================================================================
--- issm/trunk/test/NightlyRun/runme.m	(revision 12331)
+++ issm/trunk/test/NightlyRun/runme.m	(revision 12332)
@@ -30,6 +30,6 @@
 %      md=runme('id',102,'procedure','model');
 
-%Get ISSM_TIER variable
-ISSM_TIER=issmtier();
+%Get ISSM_DIR variable
+ISSM_DIR=issmdir();
 
 %Check inputs
@@ -168,5 +168,5 @@
 					message=getReport(me2);
 					if strcmpi(output,'nightly')
-						fid=fopen([ISSM_TIER '/nightlylog/matlaberror.log'], 'at');
+						fid=fopen([ISSM_DIR '/nightlylog/matlaberror.log'], 'at');
 						fprintf(fid,'%s',message);
 						fprintf(fid,'\n------------------------------------------------------------------\n');
@@ -174,5 +174,5 @@
 						disp(sprintf(['FAILURE difference: N/A test id: %i test name: %s field: %s'],id,id_string,fieldname));
 					elseif strcmpi(output,'daily');
-						fid=fopen([ISSM_TIER '/dailylog/matlaberror.log'], 'at');
+						fid=fopen([ISSM_DIR '/dailylog/matlaberror.log'], 'at');
 						fprintf(fid,'%s',message);
 						fprintf(fid,'\n------------------------------------------------------------------\n');
@@ -193,5 +193,5 @@
 		message=getReport(me);
 		if strcmpi(output,'nightly')
-			fid=fopen([ISSM_TIER '/nightlylog/matlaberror.log'], 'at');
+			fid=fopen([ISSM_DIR '/nightlylog/matlaberror.log'], 'at');
 			fprintf(fid,'%s',message);
 			fprintf(fid,'\n------------------------------------------------------------------\n');
@@ -199,5 +199,5 @@
 			disp(sprintf(['FAILURE difference: N/A test id: %i test name: %s field: %s'],id,id_string,'N/A'));
 		elseif strcmpi(output,'daily');
-			fid=fopen([ISSM_TIER '/dailylog/matlaberror.log'], 'at');
+			fid=fopen([ISSM_DIR '/dailylog/matlaberror.log'], 'at');
 			fprintf(fid,'%s',message);
 			fprintf(fid,'\n------------------------------------------------------------------\n');
Index: issm/trunk/test/NightlyRun/test102.py
===================================================================
--- issm/trunk/test/NightlyRun/test102.py	(revision 12332)
+++ issm/trunk/test/NightlyRun/test102.py	(revision 12332)
@@ -0,0 +1,9 @@
+from model import *
+from triangle import *
+from setmask import *
+from parameterize import *
+
+md=model();
+md=triangle(md,'../Exp/Square.exp',50000);
+md=setmask(md,'all','');
+md=parameterize(md,'../Par/SquareShelfConstrained.py')
Index: issm/trunk/test/NightlyRun/test448.m
===================================================================
--- issm/trunk/test/NightlyRun/test448.m	(revision 12331)
+++ issm/trunk/test/NightlyRun/test448.m	(revision 12332)
@@ -3,5 +3,4 @@
 md=parameterize(md,'../Par/SquareSheetShelf.par');
 md=setflowequation(md,'macayeal','all');
-md.cluster=none;
 md.initialization.vx(:)=0;
 md.initialization.vy(:)=0;
Index: issm/trunk/test/NightlyRun/test450.m
===================================================================
--- issm/trunk/test/NightlyRun/test450.m	(revision 12331)
+++ issm/trunk/test/NightlyRun/test450.m	(revision 12332)
@@ -3,5 +3,4 @@
 md=parameterize(md,'../Par/SquareSheetShelf.par');
 md=setflowequation(md,'macayeal','all');
-md.cluster=none;
 md.initialization.vx(:)=0;
 md.initialization.vy(:)=0;
Index: issm/trunk/test/NightlyRun/test452.m
===================================================================
--- issm/trunk/test/NightlyRun/test452.m	(revision 12331)
+++ issm/trunk/test/NightlyRun/test452.m	(revision 12332)
@@ -2,5 +2,4 @@
 md=setmask(md,'../Exp/SquareShelf.exp','');
 md=parameterize(md,'../Par/SquareSheetShelf.par');
-md.cluster=none;
 md.initialization.vx(:)=0;
 md.initialization.vy(:)=0;
Index: issm/trunk/test/Par/SquareShelfConstrained.py
===================================================================
--- issm/trunk/test/Par/SquareShelfConstrained.py	(revision 12332)
+++ issm/trunk/test/Par/SquareShelfConstrained.py	(revision 12332)
@@ -0,0 +1,59 @@
+from numpy import *
+from verbose import *
+import scipy.io as matio
+import InterpFromMeshToMesh2d as im
+from   paterson import  *
+
+#Start defining model parameters here
+#Geometry
+hmin = 300.
+hmax = 1000.
+ymin = min(md.mesh.y)
+ymax = max(md.mesh.y)
+
+md.geometry.thickness = hmax+(hmin-hmax)*(md.mesh.y-ymin)/(ymax-ymin)
+md.geometry.bed=-md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness;
+md.geometry.surface = md.geometry.bed+md.geometry.thickness
+
+#Initial velocity 
+mat=matio.loadmat('../Data/SquareShelfConstrained.data')
+#deal with 'F' oriented matlab matrices!
+index=mat['index'].astype(float)
+index=reshape(index.T,(len(index),3),order='F')
+
+md.initialization.vx = im.InterpFromMeshToMesh2d(index, mat['x'], mat['y'], mat['vx'], md.mesh.x, md.mesh.y)
+md.initialization.vy = im.InterpFromMeshToMesh2d(index, mat['x'], mat['y'], mat['vy'], md.mesh.x, md.mesh.y)
+md.initialization.vz = zeros(md.mesh.numberofvertices)
+md.initialization.pressure = zeros(md.mesh.numberofvertices)
+#Materials
+md.initialization.temperature = (273.-20)*ones(md.mesh.numberofvertices)
+md.materials.rheology_B = paterson(md.initialization.temperature)
+md.materials.rheology_n = 3.*ones(md.mesh.numberofelements)
+#Surface mass balance and basal melting
+md.surfaceforcings.mass_balance = 10.*ones(md.mesh.numberofvertices)
+md.basalforcings.melting_rate = 5.*ones(md.mesh.numberofvertices)
+#Friction
+pos = nonzero(md.mask.elementonfloatingice)
+md.friction.coefficient = 20.*ones(md.mesh.numberofvertices)
+md.friction.coefficient[md.mesh.elements[pos,:].astype(int)-1] =0.
+md.friction.p = ones(md.mesh.numberofelements)
+md.friction.q = ones(md.mesh.numberofelements)
+#Numerical parameters
+md.diagnostic.viscosity_overshoot = 0.0
+md.prognostic.stabilization = 1.
+md.thermal.stabilization = 1.
+md.verbose = verbose()
+md.settings.waitonlock = 30.
+md.diagnostic.restol = 0.05
+md.diagnostic.reltol = 0.05
+md.steadystate.reltol = 0.05
+md.diagnostic.abstol = nan
+md.timestepping.time_step = 1.
+md.timestepping.final_time = 3.
+#Deal with boundary conditions:
+md = SetIceShelfBC(md)
+#Change name so that no test have the same name
+A = dbstack
+if length(A) > 2.:
+    md.miscellaneous.name = A[2].file[0:0-2.]
+
